searchNodes=[{"ref":"Mix.Tasks.PlugRest.Gen.Resource.html","title":"Mix.Tasks.PlugRest.Gen.Resource","type":"task","doc":"Generates a PlugRest resource in your Plug application. mix plug_rest.gen.resource UserResource The generator will add the following files to lib/: a resource file in lib/my_app/resources/user_resource.ex The resource file path can be set with the --path option: mix plug_rest.gen.resource UserResource --path &quot;lib/my_app_web/resources&quot; By default the resource module will be named like MyApp.UserResource. This can be overridden with the --namespace option: mix plug_rest.gen.resource User --namespace MyApp.Resources In an umbrella project, run the mix task in the root of the app, or specify the app with: mix plug_rest.gen.resource UserResource --app my_app To create a resource with no tutorial comments: mix plug_rest.gen.resource UserResource --no-comments"},{"ref":"Mix.Tasks.PlugRest.Gen.Resource.html#run/1","title":"Mix.Tasks.PlugRest.Gen.Resource.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"PlugRest.html","title":"PlugRest","type":"module","doc":"This is the documentation for the PlugRest project. PlugRest includes an Elixir port of Cowboy&#39;s cowboy_rest module, and builds on top of Plug&#39;s router to help your web application dispatch requests to resource handler modules implementing REST semantics via a series of optional callbacks. To work with PlugRest, you write a module that uses PlugRest.Router, and one or more modules that use PlugRest.Resource to handle the requests. For more information on Plug see: Plug - a specification and conveniences for composable modules in between web applications"},{"ref":"PlugRest.Resource.html","title":"PlugRest.Resource","type":"behaviour","doc":"Define callbacks and REST semantics for a Resource behaviour Based on Cowboy&#39;s cowboy_rest module. It operates on a Plug connection and a handler module which implements one or more of the optional callbacks. For example, the route: resource &quot;/users/:username&quot;, MyApp.UserResource will invoke the init/2 function of MyApp.UserResource if it exists and then continue executing to determine the state of the resource. By default the resource must implement a to_html content handler which returns a &quot;text/html&quot; representation of the resource. defmodule MyApp.UserResource do use PlugRest.Resource def init(conn, state) do {:ok, conn, state} end def allowed_methods(conn, state) do {[&quot;GET&quot;], conn, state} end def resource_exists(%{params: params} = conn, _state) username = params[&quot;username&quot;] # Look up user state = %{name: &quot;John Doe&quot;, username: username} {true, conn, state} end def content_types_provided(conn, state) do {[{&quot;text/html&quot;, :to_html}], conn, state} end def to_html(conn, %{name: name} = state) do {&quot;&lt;p&gt;Hello, \#{name}&lt;/p&gt;&quot;, conn, state} end end Each callback accepts a %Plug.Conn{} struct and the current state of the resource, and returns a three-element tuple of the form {value, conn, state}. The resource callbacks are named below, along with their default values. Some functions are skipped if they are undefined. Others have no default value. allowed_methods : [&quot;GET&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot;] allow_missing_post : false charsets_provided : skip content_types_accepted : none content_types_provided : [{{&quot;text&quot;, &quot;html&quot;, %{}}, :to_html}] delete_completed : true delete_resource : false expires : nil forbidden : false generate_etag : nil is_authorized : true is_conflict : false known_methods : [&quot;GET&quot;, &quot;HEAD&quot;, &quot;POST&quot;, &quot;PUT&quot;, &quot;PATCH&quot;, &quot;DELETE&quot;, &quot;OPTIONS&quot;] languages_provided : skip last_modified : nil malformed_request : false moved_permanently : false moved_temporarily : false multiple_choices : false options : :ok previously_existed : false resource_exists : true service_available : true uri_too_long : false valid_content_headers : true valid_entity_length : true variances : [] You must also define the content handler callbacks that are specified through content_types_accepted/2 and content_types_provided/2. It is conventional to name the functions after the content types that they handle, such as from_html and to_html. The handler function which provides a representation of the resource must return a three element tuple of the form {body, conn, state}, where body is one of: binary(), which will be sent with send_resp/3 {:chunked, Enum.t}, which will use send_chunked/2 {:file, binary()}, which will use send_file/3 You can halt the resource handling from any callback and return a manual response like so: response = send_resp(conn, status_code, resp_body) {:stop, response, state} The content accepted handlers defined in content_types_accepted will be called for POST, PUT, and PATCH requests. By default, the response body will be empty. If desired, you can set the response body like so: conn2 = put_rest_body(conn, &quot;\#{conn.method} was successful&quot;) {true, conn2, state} Configuration You can change some defaults by configuring the :plug_rest app in your config.exs file. To change the default known_methods for all Resources: config :plug_rest, known_methods: [&quot;GET&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot;, &quot;TRACE&quot;] If a Resource implements the known_methods callback, that list always takes precedence over the default list. Plug Pipeline You can create a custom Plug pipeline within your resource using Plug.Builder: defmodule MessageResource do use PlugRest.Resource # Add the Builder to your resource use Plug.Builder # Add your custom plugs plug :hello # Finally, call the :rest plug to start executing the REST callbacks plug :rest # REST Callbacks def to_html(conn, state) do {conn.private.message, conn, state} end # Example custom plug function def hello(conn, _opts) do put_private(conn, :message, &quot;Hello&quot;) end end"},{"ref":"PlugRest.Resource.html#c:allow_missing_post/2","title":"PlugRest.Resource.allow_missing_post/2","type":"callback","doc":"Returns whether POST is allowed when the resource doesn&#39;t exist Methods: POST Default: false This function will be called when resource_exists is false and the request method is POST. Returning true means the missing resource can process the enclosed representation, and the resource&#39;s content accepted handler will be invoked. Returning true means POST should update an existing resource and create one if it is missing. Returning false means POST to a missing resource will send 404 Not Found. Examples def allow_missing_post(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#c:allowed_methods/2","title":"PlugRest.Resource.allowed_methods/2","type":"callback","doc":"Returns the list of allowed methods Methods: all Default: [&quot;GET&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot;] Methods are case sensitive and should be given in uppercase. If the request uses a method that is not allowed, the resource will respond 405 Method Not Allowed. Examples def allowed_methods(conn, state) do {[&quot;GET,&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot;], conn, state} end"},{"ref":"PlugRest.Resource.html#c:charsets_provided/2","title":"PlugRest.Resource.charsets_provided/2","type":"callback","doc":"Returns the list of charsets the resource provides Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: Skip to the next step if undefined. The list must be ordered by priority. The first charset will be chosen if the client does not send an accept-charset header, or the first that matches. The charset should be returned as a lowercase string. Examples def charsets_provided(conn, state) do {[&quot;utf-8&quot;], conn, state} end"},{"ref":"PlugRest.Resource.html#c:content_types_accepted/2","title":"PlugRest.Resource.content_types_accepted/2","type":"callback","doc":"Returns the list of content-types the resource accepts Methods: POST, PUT, PATCH Default: Crash if undefined. The list must be ordered by priority. Each content-type can be given either as a string like &quot;text/html&quot;; or a tuple in the form {type, subtype, params}, where params can be %{} (no params acceptable), :* (all params acceptable), or a map of acceptable params %{&quot;level&quot; =&gt; &quot;1&quot;}. If no content types match, a 415 Unsupported Media Type response will be sent. Examples def content_types_accepted(conn, state) do {[{&quot;application/json&quot;, :from_json}], conn, state} end The content accepted handler value is the name of the callback that will be called if the content-type matches. It is defined as follows. Value type: true | {true, URL} | false Default: Crash if undefined. Process the request body This function should create or update the resource based on the request body and the method used. Consult the Plug.Conn and Plug.Parsers docs for information on parsing and reading the request body params. Returning true means the process was successful. Returning {true, URL} means a new resource was created at that location. Returning false will send a 400 Bad Request response. If a response body must be sent, the appropriate media-type, charset and language can be manipulated using Plug.Conn. The body can be set using put_rest_body/2. Examples # post accepted def from_json(conn, :success = state) do conn = put_rest_body(conn, &quot;{\\&quot;status\\&quot;: \\&quot;ok\\&quot;}&quot;) {true, conn, state} end # post create and redirect def from_json(conn, :redirect = state) do {{true, &quot;new_url/1234&quot;}, conn, state} end # post error def from_json(conn, :error = state) do {false, conn, state} end"},{"ref":"PlugRest.Resource.html#c:content_types_provided/2","title":"PlugRest.Resource.content_types_provided/2","type":"callback","doc":"Returns the list of content-types the resource provides Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: [{{&quot;text&quot;, &quot;html&quot;, %{}}, :to_html}] The list must be ordered by priority. Each content-type can be given either as a string like &quot;text/html&quot;; or a tuple in the form {type, subtype, params}, where params can be %{} (no params acceptable), :* (all params acceptable), or a map of acceptable params %{&quot;level&quot; =&gt; &quot;1&quot;}. PlugRest will choose the content-type through content negotiation with the client. If content negotiation fails, a 406 Not Acceptable response will be sent. Examples def content_types_provided(conn, state) do {[{&quot;application/json&quot;, :to_json}], conn, state} end The content provided handler names a function that will return a representation of the resource using that content-type. It is defined as follows. Methods: GET, HEAD Value type: binary() | {:chunked, Enum.t} | {:file, binary()} Default: Crash if undefined. Return the response body. Examples def to_json(conn, state) do {&quot;{}&quot;, conn, state} end"},{"ref":"PlugRest.Resource.html#c:delete_completed/2","title":"PlugRest.Resource.delete_completed/2","type":"callback","doc":"Returns whether the delete action has been completed Methods: DELETE Default: true This function is called after a successful delete_resource. Returning true means the delete has completed. Returning false means the request was accepted but may not have finished, and responds with 202 Accepted. Examples def delete_completed(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#c:delete_resource/2","title":"PlugRest.Resource.delete_resource/2","type":"callback","doc":"Deletes the resource Methods: DELETE Default: false Returning true means the delete request can be enacted. Returning false will send a 500 error. Examples def delete_resource(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#c:expires/2","title":"PlugRest.Resource.expires/2","type":"callback","doc":"Returns the date of expiration of the resource Methods: GET, HEAD Default: nil This date will be sent as the value of the expires header. The date can be specified as a datetime() tuple or a string. Examples def expires(conn, state) do {{{2012, 9, 21}, {22, 36, 14}}, conn, state} end"},{"ref":"PlugRest.Resource.html#c:forbidden/2","title":"PlugRest.Resource.forbidden/2","type":"callback","doc":"Returns whether access to the resource is forbidden Methods: all Default: false Returning true will send a 403 Forbidden response. Examples def forbidden(conn, state) do {false, conn, state} end"},{"ref":"PlugRest.Resource.html#c:generate_etag/2","title":"PlugRest.Resource.generate_etag/2","type":"callback","doc":"Returns the entity tag of the resource Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: nil This value will be sent as the value of the etag header. Examples # ETag: W/&quot;etag-header-value&quot; def generate_etag(conn, state) do {{:weak, &quot;etag-header-value&quot;}, conn, state} end # ETag: &quot;etag-header-value&quot; def generate_etag(conn, state) do {{:strong, &quot;etag-header-value&quot;}, conn, state} end # ETag: &quot;etag-header-value&quot; def generate_etag(conn, state) do {&quot;\\&quot;etag-header-value\\&quot;&quot;}, conn, state} end"},{"ref":"PlugRest.Resource.html#get_rest_body/1","title":"PlugRest.Resource.get_rest_body/1","type":"function","doc":"Returns the REST response body if it has been set"},{"ref":"PlugRest.Resource.html#c:init/2","title":"PlugRest.Resource.init/2","type":"callback","doc":"Sets up the connection and handler state before other REST callbacks Methods: all Default: :ok Examples def init(conn, state) do {:ok, conn, state} end"},{"ref":"PlugRest.Resource.html#c:is_authorized/2","title":"PlugRest.Resource.is_authorized/2","type":"callback","doc":"Returns whether the user is authorized to perform the action Methods: all Default: true Returning {false, binary()} will send a 401 Unauthorized response. The value of the binary() will be set as the WWW-authenticate header. Examples def is_authorized(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#c:is_conflict/2","title":"PlugRest.Resource.is_conflict/2","type":"callback","doc":"Returns whether the PUT action results in a conflict Methods: PUT Default: false Returning true will send a 409 Conflict response. Examples def is_conflict(conn, state) do {false, conn, state} end"},{"ref":"PlugRest.Resource.html#c:known_methods/2","title":"PlugRest.Resource.known_methods/2","type":"callback","doc":"Returns the list of known methods Methods: all Default: [&quot;GET&quot;, &quot;HEAD&quot;, &quot;POST&quot;, &quot;PUT&quot;, &quot;PATCH&quot;, &quot;DELETE&quot;, &quot;OPTIONS&quot;] Specifies the full list of HTTP methods known by the server, even if they aren&#39;t allowed in this resource. The default list can be configured in config.exs: config :plug_rest, known_methods: [&quot;GET&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot;, &quot;TRACE&quot;] If a Resource implements the known_methods callback, that list always takes precedence over the default list. Methods are case sensitive and should be given in uppercase. Examples def known_methods(conn, state) do {[&quot;GET&quot;, &quot;HEAD&quot;, &quot;POST&quot;, &quot;PUT&quot;, &quot;PATCH&quot;, &quot;DELETE&quot;, &quot;OPTIONS&quot;], conn, state} end"},{"ref":"PlugRest.Resource.html#c:languages_provided/2","title":"PlugRest.Resource.languages_provided/2","type":"callback","doc":"Returns the list of languages the resource provides Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: Skip to the next step if undefined. The first language will be chosen if the client does not send an accept-language header, or the first that matches. The language should be returned as a lowercase binary. Examples def languages_provided(conn, state) do {[&quot;en&quot;], conn, state} end"},{"ref":"PlugRest.Resource.html#c:last_modified/2","title":"PlugRest.Resource.last_modified/2","type":"callback","doc":"Returns the date of last modification of the resource Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: nil Returning a datetime() tuple will set the last-modified header and be used for comparison in conditional if-modified-since and if-unmodified-since requests. Examples def last_modified(conn, state) do {{{2012, 9, 21}, {22, 36, 14}}, conn, state} end"},{"ref":"PlugRest.Resource.html#c:malformed_request/2","title":"PlugRest.Resource.malformed_request/2","type":"callback","doc":"Returns whether the request is malformed Methods: all Default: false Returning true will send a 400 Bad Request response. Examples def malformed_request(conn, state) do {false, conn, state} end"},{"ref":"PlugRest.Resource.html#c:moved_permanently/2","title":"PlugRest.Resource.moved_permanently/2","type":"callback","doc":"Returns whether the resource was permanently moved Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: false Returning {true, URI} will send a 301 Moved Permanently response with the URI in the Location header. Examples def moved_permanently(conn, state) do {{true, &quot;/new_location&quot;}, conn, state} end"},{"ref":"PlugRest.Resource.html#c:moved_temporarily/2","title":"PlugRest.Resource.moved_temporarily/2","type":"callback","doc":"Returns whether the resource was temporarily moved Methods: GET, HEAD, POST, PATCH, DELETE Default: false Returning {true, URI} will send a 307 Temporary Redirect response with the URI in the Location header. Examples def moved_temporarily(conn, state) do {{true, &quot;/new_location&quot;}, conn, state} end"},{"ref":"PlugRest.Resource.html#c:multiple_choices/2","title":"PlugRest.Resource.multiple_choices/2","type":"callback","doc":"Returns whether there are multiple representations of the resource Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: false Returning true means that multiple representations of the resource are possible and one cannot be chosen automatically. This will send a 300 Multiple Choices response. The response body should include information about the different representations using set_rest_body/2. The content-type that was already negotiated can be retrieved by calling: [content-type] = get_resp_header(conn, &quot;content-type&quot;) Examples def multiple_choices(conn, state) do {false, conn, state} end"},{"ref":"PlugRest.Resource.html#c:options/2","title":"PlugRest.Resource.options/2","type":"callback","doc":"Handles a request for information Methods: OPTIONS Default: true The response should inform the client the communication options available for this resource. By default, PlugRest will send a 200 OK response with the list of supported methods in the Allow header. Examples def options(conn, state) do {:ok, conn, state} end"},{"ref":"PlugRest.Resource.html#c:previously_existed/2","title":"PlugRest.Resource.previously_existed/2","type":"callback","doc":"Returns whether the resource existed previously Methods: GET, HEAD, POST, PATCH, DELETE Default: false Returning true will invoke moved_permanently and moved_temporarily to determine whether to send a 301 Moved Permanently, 307 Temporary Redirect, or 410 Gone response. Examples def previously_existed(conn, state) do {false, conn, state} end"},{"ref":"PlugRest.Resource.html#put_rest_body/2","title":"PlugRest.Resource.put_rest_body/2","type":"function","doc":"Manually sets the REST response body in the connection"},{"ref":"PlugRest.Resource.html#c:resource_exists/2","title":"PlugRest.Resource.resource_exists/2","type":"callback","doc":"Returns whether the resource exists Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: true Returning false will send a 404 Not Found response, unless the method is POST and allow_missing_post is true. Examples def resource_exists(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#c:service_available/2","title":"PlugRest.Resource.service_available/2","type":"callback","doc":"Returns whether the service is available Methods: all Default: true Use this to confirm all backend systems are up. Returning false will send a 503 Service Unavailable response. Examples def service_available(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#upgrade/3","title":"PlugRest.Resource.upgrade/3","type":"function","doc":"Executes the REST state machine with a connection and resource Accepts a Plug.Conn struct, a PlugRest.Resource module, and the initial state of the resource, and executes the REST state machine."},{"ref":"PlugRest.Resource.html#c:uri_too_long/2","title":"PlugRest.Resource.uri_too_long/2","type":"callback","doc":"Returns whether the requested URI is too long Methods: all Default: false Returning true will send a 414 Request-URI Too Long response. Examples def uri_too_long(conn, state) do {false, conn, state} end"},{"ref":"PlugRest.Resource.html#c:valid_content_headers/2","title":"PlugRest.Resource.valid_content_headers/2","type":"callback","doc":"Returns whether the content-* headers are valid Methods: all Default: true This functions should check for invalid or unknown content-* headers. Returning false will send a 501 Not Implemented response. Examples def valid_content_headers(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#c:valid_entity_length/2","title":"PlugRest.Resource.valid_entity_length/2","type":"callback","doc":"Returns whether the request body length is within acceptable boundaries Methods: all Default: true Returning false will send a 413 Request Entity Too Large response. Examples def valid_entity_length(conn, state) do {true, conn, state} end"},{"ref":"PlugRest.Resource.html#c:variances/2","title":"PlugRest.Resource.variances/2","type":"callback","doc":"Return the list of headers that affect the representation of the resource Methods: GET, HEAD, POST, PUT, PATCH, DELETE Default: [] This function may return a list of strings saying which headers should be included in the response&#39;s Vary header. PlugRest will automatically add the Accept, Accept-language and Accept-charset headers to the list if the respective functions were defined in the resource. Examples # vary: user-agent def variances(conn, state) do {[&quot;user-agent&quot;], conn, state} end"},{"ref":"PlugRest.Resource.html#t:accept_resource/0","title":"PlugRest.Resource.accept_resource/0","type":"type","doc":"The callback accepting a representation of the resource for a content-type"},{"ref":"PlugRest.Resource.html#t:auth_head/0","title":"PlugRest.Resource.auth_head/0","type":"type","doc":"A WWW-Authenticate header value"},{"ref":"PlugRest.Resource.html#t:charset/0","title":"PlugRest.Resource.charset/0","type":"type","doc":"A charset written in lowercase"},{"ref":"PlugRest.Resource.html#t:conn/0","title":"PlugRest.Resource.conn/0","type":"type","doc":"A %Plug.Conn{} struct representing the connection"},{"ref":"PlugRest.Resource.html#t:content_type_a/0","title":"PlugRest.Resource.content_type_a/0","type":"type","doc":"A content-type accepted handler, comprising a media type and acccept callback"},{"ref":"PlugRest.Resource.html#t:content_type_p/0","title":"PlugRest.Resource.content_type_p/0","type":"type","doc":"A content-type provided handler, comprising a media type and provide callback"},{"ref":"PlugRest.Resource.html#t:etag/0","title":"PlugRest.Resource.etag/0","type":"type","doc":"An entity tag Examples # ETag: W/&quot;etag-header-value&quot; {:weak, &quot;etag-header-value&quot;} # ETag: &quot;etag-header-value&quot; {:strong, &quot;etag-header-value&quot;} # ETag: &quot;etag-header-value&quot; {&quot;\\&quot;etag-header-value\\&quot;&quot;}"},{"ref":"PlugRest.Resource.html#t:header_name/0","title":"PlugRest.Resource.header_name/0","type":"type","doc":"The name of an HTTP header"},{"ref":"PlugRest.Resource.html#t:language/0","title":"PlugRest.Resource.language/0","type":"type","doc":"A language tag written in lowercase"},{"ref":"PlugRest.Resource.html#t:media_type/0","title":"PlugRest.Resource.media_type/0","type":"type","doc":"A representation of a content-type match"},{"ref":"PlugRest.Resource.html#t:method/0","title":"PlugRest.Resource.method/0","type":"type","doc":"An HTTP method written in uppercase"},{"ref":"PlugRest.Resource.html#t:ok/0","title":"PlugRest.Resource.ok/0","type":"type","doc":"An ok callback value"},{"ref":"PlugRest.Resource.html#t:provide_resource/0","title":"PlugRest.Resource.provide_resource/0","type":"type","doc":"The callback providing a representation of the resource for a content-type"},{"ref":"PlugRest.Resource.html#t:resource/0","title":"PlugRest.Resource.resource/0","type":"type","doc":"A Module adopting the PlugRest.Resource behaviour"},{"ref":"PlugRest.Resource.html#t:state/0","title":"PlugRest.Resource.state/0","type":"type","doc":"The state of the resource"},{"ref":"PlugRest.Resource.html#t:stop/0","title":"PlugRest.Resource.stop/0","type":"type","doc":"A stop callback value"},{"ref":"PlugRest.Resource.html#t:uri/0","title":"PlugRest.Resource.uri/0","type":"type","doc":"A URI"},{"ref":"PlugRest.Router.html","title":"PlugRest.Router","type":"module","doc":"A DSL to supplement Plug Router with a resource-oriented routing algorithm. It provides a macro to generate routes that dispatch to specific resource handlers. For example: defmodule MyApp.Router do use PlugRest.Router plug :match plug :dispatch resource &quot;/pages/:page&quot;, PageResource end The resource/4 macro accepts a request of format &quot;/pages/VALUE&quot; and dispatches it to PageResource, which must be a Plug module. See PlugRest.Resource for information on how to write a Plug module that implements REST semantics. From Plug.Router: Notice the router contains a plug pipeline and by default it requires two plugs: match and dispatch. match is responsible for finding a matching route which is then forwarded to dispatch. This means users can easily hook into the router mechanism and add behaviour before match, before dispatch or after both. Routes resource &quot;/hello&quot;, HelloResource The example above will route any requests for &quot;/hello&quot; to the HelloResource module. A route can also specify parameters which will be available to the resource: resource &quot;/hello/:name&quot;, HelloResource The value of the dynamic path segment can be read inside the HelloResource module: %{&quot;name&quot; =&gt; name} = conn.params Routes allow globbing, which will match the end of the route. The glob can be discarded: # matches all routes starting with /hello resource &quot;/hello/*_rest&quot;, HelloResource Or saved as a param for the resource to read: # matches all routes starting with /hello and saves the rest resource &quot;/hello/*rest&quot;, HelloResource If we make a request to &quot;/hello/value&quot; then conn.params will include: %{&quot;rest&quot; =&gt; [&quot;value&quot;]} A request to &quot;/hello/value/extra&quot; will populate conn.params with: %{&quot;rest&quot; =&gt; [&quot;value&quot;, &quot;extra&quot;]}"},{"ref":"PlugRest.Router.html#resource/4","title":"PlugRest.Router.resource/4","type":"macro","doc":"Main API to define resource routes. It accepts an expression representing the path, a Plug module, the options for the plug, and options for the macro. Examples resource &quot;/path&quot;, PlugModule, plug_options, macro_options Options resource/4 accepts the following options: :host - the host which the route should match. Defaults to nil, meaning no host match, but can be a string like &quot;example.com&quot; or a string ending with &quot;.&quot;, like &quot;subdomain.&quot; for a subdomain match. :private - a map of private data to merge into the connection :assigns - a map of data to merge into the connection The macro accepts options that it will pass to the Plug: resource &quot;/pages/:page&quot;, PageResource, [p: 1] You can restrict the resource to only match requests for a specific host. If the plug doesn&#39;t take any options, pass an empty list as the third argument to the macro: resource &quot;/pages/:page&quot;, PageResource, [], host: &quot;host1.example.com&quot;"},{"ref":"PlugRest.Router.html#t:options/0","title":"PlugRest.Router.options/0","type":"type","doc":"Options for a Router macro"},{"ref":"PlugRest.Router.html#t:path/0","title":"PlugRest.Router.path/0","type":"type","doc":"A URL path"},{"ref":"PlugRest.Router.html#t:plug/0","title":"PlugRest.Router.plug/0","type":"type","doc":"A Plug Module"},{"ref":"PlugRest.Router.html#t:plug_opts/0","title":"PlugRest.Router.plug_opts/0","type":"type","doc":"Options for the Plug"},{"ref":"PlugRest.RuntimeError.html","title":"PlugRest.RuntimeError","type":"exception","doc":"Raised for Runtime errors"},{"ref":"readme.html","title":"README","type":"extras","doc":"PlugRest An Elixir port of Cowboy&#39;s REST sub-protocol for Plug applications. PlugRest has two main components: PlugRest.Router - supplements Plug&#39;s router with a resource macro, which matches a URL path with a Plug module for all HTTP methods PlugRest.Resource - defines a behaviour for Plug modules to represent web resources declaratively using multiple callbacks PlugRest is perfect for creating well-behaved and semantically correct hypermedia web applications. If you use Phoenix, be sure to check out PhoenixRest. Documentation for PlugRest is available on hexdocs. Source code is available on Github. Package is available on hex. Table of Contents Introduction Installation Getting Started Information"},{"ref":"readme.html#introduction","title":"README - Introduction","type":"extras","doc":"Hello World Define a router to match a path with a resource handler: defmodule MyRouter do use PlugRest.Router plug :match plug :dispatch resource &quot;/hello&quot;, HelloResource end Define the resource handler and implement the optional callbacks: defmodule HelloResource do use PlugRest.Resource def to_html(conn, state) do {&quot;Hello world&quot;, conn, state} end end"},{"ref":"readme.html#features","title":"README - Features","type":"extras","doc":"Router Route all requests for a path to a plug, for any HTTP method Resource Built-in HEAD and OPTIONS responses, and easy handling of GET, POST, PUT, PATCH, and DELETE requests Content negotiation for media types, languages, and charsets HTTP access authentication Observance of etag, expires, last-modified, and vary headers Multiple choices for redirects, not modified responses, etc. Correct HTTP status codes for common 400 and 500 level errors"},{"ref":"readme.html#why-plugrest","title":"README - Why PlugRest?","type":"extras","doc":"The key abstraction of information in REST is a resource. —Roy Fielding In the REST architectural style, one of the uniform interface constraints is the identification of resources. Using Plug, we can satisfy this requirement by routing requests based on a URL path. PlugRest goes a step further. Rather than manually defining HTTP semantics for each route and dividing a resource&#39;s behavior over multiple controller actions, PlugRest lets us describe our resources in a declarative way (by implementing callbacks), and follows protocol for us, including returning the correct status code when something goes wrong (or right). PlugRest can help your Elixir application become a fluent speaker of the HTTP protocol. It can assist with content negotiation, cache headers, basic authentication, and redirects. However, it is not a full-featured framework with views, templates, sessions, or web sockets. It also lacks a requisite solution for hypermedia controls, which are essential to REST. PlugRest is not the first REST-based framework to take a resource-oriented approach. Basho&#39;s Webmachine has inspired many such libraries, including cowboy_rest. You can use PlugRest in a standalone web app or as part of an existing Phoenix application. Details below!"},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"If starting a new project, generate a supervisor application: $ mix new my_app --sup $ cd my_app Add PlugRest to your project in two steps: Add :plug_cowboy and :plug_rest to your list of dependencies in mix.exs: defp deps do [ {:plug_cowboy, &quot;~&gt; 2.0&quot;}, {:plug_rest, &quot;~&gt; 0.14&quot;} ] end Install the dependencies by running mix deps.get and mix deps.compile."},{"ref":"readme.html#getting-started","title":"README - Getting Started","type":"extras","doc":"Resources Create a file at lib/my_app/resources/hello_resource.ex to hold your Resource Handler: defmodule MyApp.HelloResource do use PlugRest.Resource def allowed_methods(conn, state) do {[&quot;HEAD&quot;, &quot;GET&quot;, &quot;OPTIONS&quot;], conn, state} end def content_types_provided(conn, state) do {[{&quot;text/html&quot;, :to_html}], conn, state} end def to_html(conn, state) do {&quot;Hello \#{state}&quot;, conn, state} end end Router Create a file at lib/my_app/router.ex to hold the Router: defmodule MyApp.Router do use PlugRest.Router use Plug.ErrorHandler plug :match plug :dispatch resource &quot;/hello&quot;, MyApp.HelloResource, &quot;World&quot; match &quot;/match&quot; do send_resp(conn, 200, &quot;Match&quot;) end end The PlugRest Router adds a resource macro which accepts a URL path, a Plug module, and its options. If the module is a PlugRest.Resource, it will begin executing the REST callbacks, passing in any initial state given to it. The router contains a plug pipeline and requires two plugs: match and dispatch. You can add custom plugs into this pipeline. You can also use the match macros from Plug.Router. This provides an escape hatch to bypass the REST mechanism for a particular route and send a Plug response manually. If no routes match, PlugRest will send a response with a 404 status code to the client automatically. Dynamic path segments Router paths can have segments that match URLs dynamically: resource &quot;/users/:id&quot;, MyApp.UserResource The path parameters can be accessed in your resource in conn.params: def to_html(%{params: params} = conn, state) do user_id = params[&quot;id&quot;] {&quot;Hello \#{user_id}&quot;, conn, state} end Application Finally, add the Router to your supervision tree by editing lib/my_app/application.ex: children = [ {Plug.Cowboy, scheme: :http, plug: MyApp.Router, options: [port: 4001]} ] Running Compile your application and then run it: $ mix compile $ iex -S mix Your server will be running and the resource will be available at http://localhost:4001/hello. Tasks You can generate a new PlugRest resource (with all of the callbacks implemented) by using a Mix task: $ mix plug_rest.gen.resource UserResource The task will create a resource at lib/my_app/resources/user_resource.ex. Callbacks The PlugRest.Resource module defines dozens of callbacks that offer a declarative strategy for defining a resource&#39;s behavior. Implement your desired callbacks and let this library do the REST, including returning the appropriate response headers and status code. Each callback takes two arguments: conn - a %Plug.Conn{} struct; use this to fetch details about the request (see the Plug docs for more info) state - the state of the Resource; use this to store any data that should be available to subsequent callbacks Each callback must return a three-element tuple of the form {value, conn, state}. All callbacks are optional, and will be given default values if you do not define them. Some of the most common and useful callbacks are shown below with their defaults: allowed_methods : [&quot;GET&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot;] content_types_accepted : none content_types_provided : [{{&quot;text/html&quot;}, :to_html}] expires : nil forbidden : false generate_etag : nil is_authorized : true last_modified : nil malformed_request : false moved_permanently : false moved_temporarily : false resource_exists : true The docs for PlugRest.Resource list all of the supported REST callbacks and their default values. Content Negotiation Content Types Provided You can return representations of your resource in different formats by implementing the content_types_provided callback, which pairs each content-type with a handler function: def content_types_provided(conn, state) do {[{&quot;text/html&quot;, :to_html}, {&quot;application/json&quot;, :to_json}], conn, state} end def to_html(conn, state) do {&quot;&lt;h1&gt;Hello&lt;/h1&gt;&quot;, conn, state} end def to_json(conn, state) do {&quot;{\\&quot;title\\&quot;: \\&quot;Hello\\&quot;}&quot;, conn, state} end Content Types Accepted Similarly, you can accept different media types from clients by implementing the content_types_accepted callback: def content_types_accepted(conn, state) do {[{&quot;mixed/multipart&quot;, :from_multipart}, {&quot;application/json&quot;, :from_json}], conn, state} end def from_multipart(conn, state) do # fetch or read the request body params, update the database, etc. {true, conn, state} end def from_json(conn, state) do {true, conn, state} end The content handler functions you implement can return either true, {true, URL} (for redirects), or false (for errors). Don&#39;t forget to add &quot;POST&quot;, &quot;PUT&quot;, and/or &quot;PATCH&quot; to your resource&#39;s list of allowed_methods. Consult the Plug.Conn and Plug.Parsers docs for information on parsing and reading the request body params. Testing Use Plug.Test to help verify your resource&#39;s responses to separate requests. Create a file at test/resources/hello_resource_test.exs to hold your test: defmodule MyApp.HelloResourceTest do use ExUnit.Case use Plug.Test alias MyApp.Router test &quot;get hello resource&quot; do conn = conn(:get, &quot;/hello&quot;) conn = Router.call(conn, []) assert conn.status == 200 assert conn.resp_body == &quot;Hello world&quot; end end Run the test with: $ mix test Debugging To help debug your app during development, add Plug.Debugger to the top of the router, before use Plug.ErrorHandler: defmodule MyApp.Router do use PlugRest.Router if Mix.env == :dev do use Plug.Debugger, otp_app: :my_app end use Plug.ErrorHandler # ... end Error Handling By adding use Plug.ErrorHandler to your router, you will ensure it returns correct HTTP status codes when plugs raise exceptions. To set a custom error response, add the handle_errors/2 callback to your router: defp handle_errors(conn, %{kind: _kind, reason: _reason, stack: _stack}) do send_resp(conn, conn.status, &quot;Something went wrong&quot;) end Phoenix You can use PlugRest&#39;s router and resources in your Phoenix app like any other plug by forwarding requests to them: forward &quot;/rest&quot;, HelloPhoenix.RestRouter To get the resource macro directly in your Phoenix router, use PhoenixRest."},{"ref":"readme.html#information","title":"README - Information","type":"extras","doc":"The Cowboy documentation has more details on the REST protocol: REST principles REST flowcharts Designing a resource handler Upgrading PlugRest is still in an initial development phase. Expect breaking changes at least in each minor version. See the CHANGELOG for more information."},{"ref":"readme.html#license","title":"README - License","type":"extras","doc":"PlugRest copyright &copy; 2016, Christopher Adams cowboy_rest copyright &copy; 2011-2014, Loïc Hoguin essen@ninenines.eu Plug copyright &copy; 2013 Plataformatec. PlugRest source code is licensed under the Apache License, Version 2.0."}]